var jq_txgz_avatar2 = jQuery.noConflict(true);

var embedwidth = 0;
var embedheight = 0;
var embedsrc = '';

for (var i = 0; i < document.getElementsByTagName('embed').length; i++) {
    var embed = document.getElementsByTagName('embed')[i];
    if (embed.getAttribute("name") == 'mycamera') {
        embedwidth = embed.width;
        embedheight = embed.height;
        embedsrc = embed.src;
    }
}

var dwidth = embedwidth;
var dheight = embedheight;
var avatarform;

if (isCanvasSupported()) {
    replaceAvatarSection(document.getElementById('avatardesigner'));
    avatarform = jq_txgz_avatar2('#avatardesigner').closest('form').get(0);
    jq_txgz_avatar2('#avatardesigner').show();
    jq_txgz_avatar2('#avatardesigner').width(dwidth);
    jq_txgz_avatar2('#avatardesigner').height(dheight);
    jq_txgz_avatar2('#avatarfileselector').height(dheight - 5);
    jq_txgz_avatar2('#widgetparent').width(dwidth - 150);
    jq_txgz_avatar2('#widgetparent').height(dheight);
    jq_txgz_avatar2('#selector').width(150);
    jq_txgz_avatar2('#selector').height(150);
    // http://stackoverflow.com/questions/6908094/rectangle-on-html5-canvas-is-stretched
    jq_txgz_avatar2('#avatarcanvas').attr('width', (dwidth - 150));
    jq_txgz_avatar2('#avatarcanvas').attr('height', dheight);
    document.write("<style>.imgl img { max-width: " + (dwidth / 5 - 15) + "px; }</style>");
    document.getElementById('actionurl').value = embedsrc.replace('images/camera.swf?inajax=1', 'index.php?m=user&a=uploadavatar');
    avatarform.target = 'uploadframe';
    avatarform.enctype = 'multipart/form-data';
}

var avatardisplaysrcs = [];

jq_txgz_avatar2(document).ready(function () {
    jq_txgz_avatar2("#selector")
        .draggable({
            containment: "parent",
            drag: function (event, ui) { refreshAvatarCanvas(ui.position); },
            stop: function () { forceSelectorInsideAvatar(); }
        })
        .resizable({
            containment: "parent",
            handles: {
                'ne': '#negrip',
                'se': '#segrip',
                'sw': '#swgrip',
                'nw': '#nwgrip',
                'n': '#ngrip',
                'e': '#egrip',
                's': '#sgrip',
                'w': '#wgrip'
            },
            resize: function (event, ui) { refreshAvatarCanvas(ui.position); },
            stop: function () { forceSelectorInsideAvatar(); }
        })
        .hover(
            function () { jq_txgz_avatar2(this).css({ "border-color": "red" }); },
            function () { jq_txgz_avatar2(this).css({ "border-color": "rgba(255, 0, 0, 0.6)" }); }
        );
    jq_txgz_avatar2("#slider").slider({
        min: 0,
        max: 100,
        value: 50,
        slide: function (event, ui) {
            forceSelectorInsideAvatar();
        }
    });
    jq_txgz_avatar2("#slider").append("<div style='position: absolute; top: -2px; left: 0px; width: 3px; height: 6px; background-color: black;'>&nbsp;</div>");
    jq_txgz_avatar2("#slider").append("<div style='position: absolute; top: -2px; left: 50px; width: 3px; height: 6px; background-color: black;'>&nbsp;</div>");
    jq_txgz_avatar2("#slider").append("<div style='position: absolute; top: -2px; left: 100px; width: 3px; height: 6px; background-color: black;'>&nbsp;</div>");

    jq_txgz_avatar2('img', '#avatardisplayer').each(function () {
        avatardisplaysrcs.push(jq_txgz_avatar2(this).attr('src'));
        jq_txgz_avatar2(this).attr('src', '');
    });

    jq_txgz_avatar2("#avatarimage").load(function () {
        var imageSrc = jq_txgz_avatar2("#avatarimage").attr("src");
        jq_txgz_avatar2("#avatarinback").attr("src", imageSrc);
        jq_txgz_avatar2("#avatarinselection").attr("src", imageSrc);
        jq_txgz_avatar2("#avatarinselection").css("background-image", "url(" + imageSrc + ")");
        jq_txgz_avatar2("#slider").slider('value', 50);
        // http://api.jquery.com/load-event/
        setTimeout(function () {
            jq_txgz_avatar2('#avatarfileselector').hide();
            jq_txgz_avatar2('#avatardisplayer').hide();
            jq_txgz_avatar2('#avataradjuster').show();
            forceSelectorInsideAvatar();
        }, 100);
    });

    jq_txgz_avatar2('#uploadframe').load(function () {
        uploadAvatarDone();
    });
    jq_txgz_avatar2('#rectframe').load(function () {
        rectAvatarDone();
    });

});

function uploadAvatarDone() {
    var iframe = document.getElementById('uploadframe');
    var iframeDocument = iframe.contentDocument || iframe.contentWindow.document;
    if (!iframeDocument.body) return;
    var imageSrc = iframeDocument.body.innerHTML;
    if (!imageSrc) return;
    if (imageSrc.indexOf('http') !== 0) { // server returns error message
        if (imageSrc != -4) { // ie11 bug?: called twice, the value in the second time is -4
            alert(upload_error);
        }
        return;
    }
    // http://stackoverflow.com/questions/1703228/how-to-clear-file-input-with-javascript
    try {
        var av = document.getElementById('avatarfile');
        av.value = '';
        if (av.value) {
            av.type = "text";
            av.type = "file";
        }
    } catch (e) { }
    jq_txgz_avatar2('#selector').css({ left: Math.floor((dwidth - 300) / 2), top: Math.floor((dheight - 150) / 2), width: 150, height: 150 });
    // http://stackoverflow.com/questions/1077041/refresh-image-with-a-new-one-at-the-same-url
    imageSrc += "?" + Date.now();
    jq_txgz_avatar2("#avatarimage").attr("src", imageSrc);
}

function showAvatarFileSelector() {
    jq_txgz_avatar2('#avatarimage').attr('src', '');
    jq_txgz_avatar2('#avatarinback').attr('src', '');
    jq_txgz_avatar2('#avatarinselection').attr('src', '');
    jq_txgz_avatar2('#avatarinselection').css('background-image', '');
    jq_txgz_avatar2('#avataradjuster').css('display', 'none');
    jq_txgz_avatar2('#avatardisplayer').css('display', 'none');
    jq_txgz_avatar2('img', '#avatardisplayer').each(function () {
        jq_txgz_avatar2(this).attr('src', '');
    });
    jq_txgz_avatar2('#avatarfileselector').css('display', 'block');
}

function getAvatarDimension() {
    var factor = jq_txgz_avatar2('#slider').slider('option', 'value');
    var cw = jq_txgz_avatar2('#widgetparent').width();
    var ch = jq_txgz_avatar2('#widgetparent').height();
    var iw = jq_txgz_avatar2('#avatarimage').width();
    var ih = jq_txgz_avatar2('#avatarimage').height();
    var minw = 48;
    var minh = 48;
    var midw = Math.min(Math.max(iw, 48), cw);
    var midh = Math.min(Math.max(ih, 48), ch);
    var maxw = Math.max(Math.max(iw, 48), cw);
    var maxh = Math.max(Math.max(ih, 48), ch);
    var minr = Math.max(minw / iw, minh / ih);
    var midr = Math.max(midw / iw, midh / ih);
    var maxr = Math.max(maxw / iw, maxh / ih);
    if (factor <= 50) {
        r = (minr * (50 - factor) + midr * factor) / 50;
    }
    else {
        r = (midr * (100 - factor) + maxr * (factor - 50)) / 50;
    }
    var aw = r * iw;
    var ah = r * ih;
    var al = (cw - aw) / 2;
    var at = (ch - ah) / 2;
    var sd = getSelectorDimention();
    if (aw > cw) al = (cw - aw) / (cw - sd.width) * sd.left;
    if (ah > ch) at = (ch - ah) / (ch - sd.height) * sd.top;
    return { left: Math.floor(al), top: Math.floor(at), width: Math.floor(aw), height: Math.floor(ah) };
}

function refreshAvatarCanvas(uiposition) {
    var ad = getAvatarDimension();
    var sd = getSelectorDimention();
    // http://stackoverflow.com/questions/6258834/jquery-ui-draggable-event-timing
    if (uiposition) {
        sd.left = uiposition.left;
        sd.top = uiposition.top;
    }
    jq_txgz_avatar2("#avatarinback").css({ left: ad.left, top: ad.top, width: ad.width, height: ad.height });
    var left = jq_txgz_avatar2('#avatarinback').position().left - sd.left - 2; // border width is 2
    var top = jq_txgz_avatar2('#avatarinback').position().top - sd.top - 2;
    jq_txgz_avatar2("#avatarinselection").css({ left: Math.ceil(left), top: Math.ceil(top), width: ad.width });
}

function getSelectorDimention() {
    var sl = jq_txgz_avatar2('#selector').position().left;
    var st = jq_txgz_avatar2('#selector').position().top;
    var sw = jq_txgz_avatar2('#selector').width();
    var sh = jq_txgz_avatar2('#selector').height();
    return { left: Math.ceil(sl), top: Math.ceil(st), width: Math.ceil(sw), height: Math.ceil(sh) };
}

function forceSelectorInsideAvatar() {
    var sd = getSelectorDimention();
    var ad = getAvatarDimension();
    if (sd.width > ad.width) jq_txgz_avatar2('#selector').width(ad.width);
    if (sd.height > ad.height) jq_txgz_avatar2('#selector').height(ad.height);
    sd = getSelectorDimention();
    if (sd.left < ad.left) jq_txgz_avatar2('#selector').css('left', ad.left);
    if (sd.top < ad.top) jq_txgz_avatar2('#selector').css('top', ad.top);
    if (sd.left + sd.width > ad.left + ad.width) jq_txgz_avatar2('#selector').css('left', ad.left + ad.width - sd.width);
    if (sd.top + sd.height > ad.top + ad.height) jq_txgz_avatar2('#selector').css('top', ad.top + ad.height - sd.height);
    refreshAvatarCanvas();
}

function saveAvatar() {
    jq_txgz_avatar2("body").css("cursor", "progress");

    var sd = getSelectorDimention();
    var ad = getAvatarDimension();
    var rl = (sd.left - ad.left) / ad.width;
    var rt = (sd.top - ad.top) / ad.height;
    var rw = sd.width / ad.width;
    var rh = sd.height / ad.height;
    var iw = jq_txgz_avatar2('#avatarimage').width();
    var ih = jq_txgz_avatar2('#avatarimage').height();
    var sl = rl * iw;
    var st = rt * ih;
    var sw = rw * iw;
    var sh = rh * ih;
    var tw = sw;
    var th = sh;
    if (sw > 200 || sh > 250) {
        var r = Math.max(sw / 200, sh / 250);
        tw = sw / r;
        th = sh / r;
    }
    var imageSrc = jq_txgz_avatar2("#avatarimage").attr("src");
    ajaxget('plugin.php?id=txgz_avatar2:avatar_gen&imageurl=' + imageSrc + '&sl=' + Math.floor(sl) + '&st=' + Math.floor(st) + '&sw=' + Math.floor(sw) + '&sh=' + Math.floor(sh) + '&tw=' + Math.floor(tw) + '&th=' + Math.floor(th), 'davatar1', 'wait');

    var tw = sw;
    var th = sh;
    if (sw > 120 || sh > 120) {
        var r = Math.max(sw / 120, sh / 120);
        tw = sw / r;
        th = sh / r;
    }
    ajaxget('plugin.php?id=txgz_avatar2:avatar_gen&imageurl=' + imageSrc + '&sl=' + Math.floor(sl) + '&st=' + Math.floor(st) + '&sw=' + Math.floor(sw) + '&sh=' + Math.floor(sh) + '&tw=' + Math.floor(tw) + '&th=' + Math.floor(th), 'davatar2', 'wait');

    var mwh = Math.min(sw, sh);
    if (sw > mwh) {
        sl += (sw - mwh) / 2;
        sw = mwh;
    }
    if (sh > mwh) {
        st += (sh - mwh) / 2;
        sh = mwh;
    }
    var tw = 48;
    var th = 48;
    ajaxget('plugin.php?id=txgz_avatar2:avatar_gen&imageurl=' + imageSrc + '&sl=' + Math.floor(sl) + '&st=' + Math.floor(st) + '&sw=' + Math.floor(sw) + '&sh=' + Math.floor(sh) + '&tw=' + Math.floor(tw) + '&th=' + Math.floor(th), 'davatar3', 'wait');

    avatarform.action = document.getElementById('actionurl').value.replace('&a=uploadavatar', '&a=rectavatar');
    avatarform.target = 'rectframe';

    var intervalc = 0;
    var interval = setInterval(function () {
        intervalc++;
        var done = isAvatarSavingDone();
        if (done || intervalc > 100) clearInterval(interval);
        if (done) avatarform.submit();
        if (intervalc > 100) alert(upload_error);
    }, 100);
}

function isAvatarSavingDone() {
    var img1 = jq_txgz_avatar2('#davatar1').html();
    if (img1) jq_txgz_avatar2('#avatar1').val(flashdata_encode(atob(img1)));
    var img2 = jq_txgz_avatar2('#davatar2').html();
    if (img2) jq_txgz_avatar2('#avatar2').val(flashdata_encode(atob(img2)));
    var img3 = jq_txgz_avatar2('#davatar3').html();
    if (img3) jq_txgz_avatar2('#avatar3').val(flashdata_encode(atob(img3)));
    return (img1 && img2 && img3) ? true : false;
}

function rectAvatarDone() {
    var iframe = document.getElementById('rectframe');
    var iframeDocument = iframe.contentDocument || iframe.contentWindow.document;
    var faces = iframeDocument.getElementsByTagName("face");
    if (faces.length == 0) return;
    jq_txgz_avatar2("body").css("cursor", "default");
    var res = faces[0].getAttribute("success");
    if (res == 1) {
        jq_txgz_avatar2('#avatardisplayer').show();
        jq_txgz_avatar2('#avataradjuster').hide();
        jq_txgz_avatar2('#avatarfileselector').hide();
        jq_txgz_avatar2('img', '#avatardisplayer').each(function (i) {
            var src = avatardisplaysrcs[i] + ((avatardisplaysrcs[i].indexOf("?")>=0)?"&":"?") + "random=" + Date.now();
            jq_txgz_avatar2(this).attr("src", src);
        });
    }
    else {
        alert(upload_error);
    }
}

function flashdata_encode(s) {
    var r = '';
    var l = s.length;
    for (var i = 0; i < l; i++) {
        var k = s[i].charCodeAt(0);
        var k1 = k >> 4;
        var k2 = k - (k1 << 4);
        k1 += 48;
        if (k1 > 57) k1 += 7;
        k2 += 48;
        if (k2 > 57) k2 += 7;
        r += String.fromCharCode(k1, k2);
    }
    return r;
}

// copied from template/default/home/editor_image_menu.htm
function switchImagebutton(btn) {
    switchButton(btn, 'image');
    doane();
}

function picView(albumid, listid) {
    if (albumid == 'none') {
        $(listid).innerHTML = '';
    } else {
        ajaxget('home.php?mod=misc&ac=ajax&op=album&id=' + albumid + '&ajaxdiv=albumpic_body', listid);
    }
}

function insertImage(url) {
    jq_txgz_avatar2('#album_pic_url').val(url);
    avatarform.action = 'plugin.php?id=txgz_avatar2:avatar';
    avatarform.submit();
}

function replaceAvatarSection(html5section) {
    html5section.parentNode.removeChild(html5section);
    for (var i = 0; i < document.getElementsByTagName('embed').length; i++) {
        var embed = document.getElementsByTagName('embed')[i];
        if (embed.getAttribute("name") == 'mycamera') {
            embed.parentNode.replaceChild(html5section, embed);
        }
    }
}

//http://stackoverflow.com/questions/2745432/best-way-to-detect-that-html5-canvas-is-not-supported
function isCanvasSupported() {
    var elem = document.createElement('canvas');
    return !!(elem.getContext && elem.getContext('2d'));
}